public class Car {
    private String make;
    private String model;
    private int year;

    public Car(String make, String model, int year) {
        this.make = make;
        this.model = model;
        this.year = year;
    }

    public String getMake() {
        return this.make;
    }

    public String getModel() {
        return this.model;
    }

    public int getYear() {
        return this.year;
    }

    @Override
    public int hashCode() {
        return Math.abs(31 * this.make.hashCode() * this.model.hashCode() * this.year);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        } else if (o instanceof Car) {
            Car other = (Car) o;
            return this.make.equals(other.make) &&
                    this.model.equals(other.model) &&
                    this.year == other.year;
        } else {
            return false;
        }
    }
}
