import java.util.*;

public class HashingTest {
    public static void main(String[] args) {
        ArrayList<Car> carList = new ArrayList<>();

        Car car1 = new Car("Honda", "Accord", 2015);
        Car car2 = new Car("Ford", "Mustang", 2022);
        Car car3 = new Car("Chevrolet", "Camaro", 2018);
        Car car4 = new Car("Toyota", "Corolla", 2019);
        Car car5 = new Car("Tesla", "Model S", 2021);
        Car car6 = new Car("BMW", "X5", 2020);
        Car car7 = new Car("Mercedes-Benz", "E-Class", 2017);
        Car car8 = new Car("Audi", "Q7", 2022);
        Car car9 = new Car("Lexus", "RX", 2016);
        Car car10 = new Car("Subaru", "Outback", 2023);
        Car car11 = new Car("Nissan", "Altima", 2017);
        Car car12 = new Car("Hyundai", "Elantra", 2019);
        Car car13 = new Car("Mazda", "CX-5", 2022);
        Car car14 = new Car("Jeep", "Wrangler", 2018);
        Car car15 = new Car("Tesla", "X", 2018);


        carList.add(car1);
        carList.add(car2);
        carList.add(car3);
        carList.add(car4);
        carList.add(car5);
        carList.add(car6);
        carList.add(car7);
        carList.add(car8);
        carList.add(car9);
        carList.add(car10);
        carList.add(car11);
        carList.add(car12);
        carList.add(car13);
        carList.add(car14);
        carList.add(car15);
        timeArrayList(carList);
        timeGarage(carList);
    }

    // run a test for an ArrayList
    public static void timeArrayList(List<Car> data) {
        long start = System.currentTimeMillis();
        List<Car> lst = new ArrayList<>();
        for (int i = 0; i < data.size(); i++) {
            if (i % 5 == 0) {
                lst.remove(data.get(i));
            } else if (i % 5 == 1) {
                lst.contains(data.get(i));
            } else if (!lst.contains(data.get(i))) {
                lst.add(data.get(i));
            }
        }
        System.out.println("list size after = " + lst.size());
        double elapsed = (System.currentTimeMillis() - start) / 1000.0;
        System.out.println("ArrayList time = " + elapsed);
    }

    // run a test for our implementation of a hash table (Garage)
    public static void timeGarage(List<Car> data) {
        long start = System.currentTimeMillis();
        Garage s = new Garage();
        for (int i = 0; i < data.size(); i++) {
            if (i % 5 == 0) {
                s.remove(data.get(i));
            } else if (i % 5 == 1) {
                s.contains(data.get(i));
            } else {
                s.add(data.get(i));
            }
        }
        System.out.println("Garage size after = " + s.size());
        double elapsed = (System.currentTimeMillis() - start) / 1000.0;
        System.out.println("Garage time = " + elapsed);
    }
}
